/*******************************************************************************
*    BitmapButton für wxWidget 1.0.                                            *
*    Copyright (C) 2013-averyfarwaydate Luca Bertoncello                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

#ifndef BITMAPBUTTON_H_
#define BITMAPBUTTON_H_

#include <wx/wx.h>
#include <wx/dcbuffer.h>

class BitmapButton : public wxControl
{
public:
  BitmapButton(wxWindow *parent, wxWindowID id, const wxBitmap& bitmap, wxBitmap& background,
           const wxString &label, const wxPoint& pos = wxDefaultPosition,
           const wxSize& size = wxDefaultSize, const wxBitmap& toggle = wxBitmap(),
           const wxColour& textColour = *wxBLACK, bool toggledStatus = false);
  virtual ~BitmapButton();
  void setTextColour(wxColour colour);
  void setToggleBitmap(wxBitmap toggle);
  void setToggled(bool toggled);
  void setLabelX(int x);
  void setLabelY(int y);
  void setFontSize(int size);
  void setBold(bool bold);
  void setItalic(bool italic);
  void setLongPressTime(long time);

protected:
  void OnSize(wxSizeEvent& event);
  void OnPaint(wxPaintEvent& event);
  void OnClick(wxCommandEvent& event);

private:
  wxWindow *parent;
  wxWindowID id;
  wxBitmap bitmap, background, toggle;
  wxPoint pos;
  wxSize size;
  wxString label;
  wxColour textColour;
  bool pressed, isToggle, prevToggled;
  int labelX, labelY, fontSize, bold, italic;
  long startPressed, startedEvent;
  long longPressTime;
};

#endif /* BITMAPBUTTON_H_ */
